#!/usr/bin/env python

""" locking modul written by Robert Penz <robert@penz.name>
"""

#***************************************************************************
#                          lock  -  description
#                             -------------------
#    copyright            : (C) 2003 by Robert Penz
#    email                : robert@penz.name
#***************************************************************************

#***************************************************************************
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation; either version 2 of the License, or     *
#*   (at your option) any later version.                                   *
#*                                                                         *
#***************************************************************************


import os


# 1 means we got the lock
# 0 someone is just running with that lock
def test_and_lock(filename):
    if os.path.isfile(filename):
        try:
            pid = int(open(filename).readline().rstrip("\n"))
            os.kill(pid,0)
            return 0
        except:
            # process doesn't exist
            pass
    # create a file with my pid
    open(filename,"w").write(str(os.getpid()))
    
    return 1
    

def unlock(filename):
    try:
        os.unlink(filename)
    except:
        pass
    

# Main program: parse command line and start processing
def main():
    print test_and_lock("/tmp/test.lock")
    print test_and_lock("/tmp/test.lock")
    unlock("/tmp/test.lock")
    

if __name__ == '__main__':
    main()
